#ifndef CLASS_INST
#define CLASS_INST

#include <stdio.h>
#include "machine.h"
#include "instbase.h"


class Defs : public Inst {

   Machine *mc;

   public:

   Defs( Machine *emc );

   int Execute( void );
   int GenCode( FILE *outf );
   void Dump( void );

};

class FProgram : public Inst {

   Machine *mc;

   public:

   FProgram( Machine *emc );

   int Execute( void );
   int GenCode( FILE *outf );
   void Dump( void );

};


class FCall : public Inst {

   Machine *mc;
   int proindex;

   public:

   FCall( Machine *emc, int eproindex );

   int Execute( void );
   int GenCode( FILE *outf );
   void Dump( void );

};

class GLabel : public Inst {

   Machine *mc;
   int labno;

   public:

   GLabel( Machine *emc, int elabno );

   int Execute( void );
   int GenCode( FILE *outf );
   void Dump( void );

};

class LLabel : public Inst {

   Machine *mc;
   int llabno;

   public:

   LLabel( Machine *emc, int ellabno );

   int Execute( void );
   int GenCode( FILE *outf );
   void Dump( void );

};


class FNumber : public Inst {

   Machine *mc;
   int val;

   public:

   FNumber( Machine *emc, int eval );

   int Execute( void );
   int GenCode( FILE *outf );
   void Dump( void );

};


class Var : public Inst {

   Machine *mc;

   int sldist;
   int reladr;
   char name[80];

   public:

   Var( Machine *emc, int esldist, int ereladr, char *ename );

   int Execute( void );
   int GenCode( FILE *outf );
   void Dump( void );

};



class Operator : public Inst {

   Machine *mc;


   public:

   char operation;

   Operator( Machine *emc, char eop );

   int Execute( void );
   int GenCode( FILE *outf );
   void Dump( void );

};


class ThenAction : public Inst {

   Machine *mc;

   public:

   int JumpTo;    // set at a later time!

   ThenAction( Machine *emc );

   int Execute( void );
   int GenCode( FILE *outf );
   void Dump( void );

};


class EndAction : public Inst {

   Machine *mc;

   public:

   EndAction( Machine *emc );

   int Execute( void );
   int GenCode( FILE *outf );
   void Dump( void );

};


class Stop : public Inst {

   Machine *mc;

   public:

   Stop( Machine *emc );

   int Execute( void );
   int GenCode( FILE *outf );
   void Dump( void );

};

#endif

