#ifndef CLASS_MACHINE
#define CLASS_MACHINE

#include "instbase.h"
#include "procdesc.h"


class Machine {

   int maxproc;
   int maxinst;
   int maxdata;



   int ip;

   int *D;

   int cur, free;

   public:

   char op;
   int val;

   int bll;

   ProcDesc **PD;
   int nextPD;

   Inst **IA;
   int nextIA;

   int currIA;    // gencode

   Machine( int emp, int emi, int emd );

   void Interpreter( int single_step );

   void DumpInst( void );
   int Generate( char *srcfile );
   int GenIt( char *asmstring, char *srcfile );

   int CreateInst( Inst *instr );
   int CreateProc( ProcDesc *proc );

   int GetIP( void );
   void SetIP( int newip );
   int GetData( int offset );
   int SetData( int offset, int val );
   int Push( int size );
   int Pop( int size );
   void SetCur( int ncur );
   int GetCur( void );
   int GetFree( void );


};


#endif

