#ifndef CLASS_PARSER
#define CLASS_PARSER

#include "reader.h"
#include "machine.h"
#include "compiler.h"

class Parser {

   int pdebug;
   Reader *l;
   Machine *mc;
   Compiler *cm;

   public:

   Parser( Reader *l, Machine *mc, int pd );

   char *AName( char *dest );
   Decl *PName( void );
   int NName( void );
   int XNameList( void );
   int NameList( void );
   int VarDecl( void );
   int Decl2( void );
   int DeclList( void );
   int Variable( void );
   int Number( void );
   int Term( void );
   int Arop( void );
   int XExpression( void );
   int Expression( void );

   int IfStmt( void );
   int Output( void );
   int Input( void );
   int Assignment( void );
   int ProcName( void );
   int Call( void );
   int Stmt( void );
   int StmtList( void );

   int ProcDecl( void );
   int Program( void );
};

#endif

