/****
 * Name: reader.cpp
 *
 * Details:
 * Reads a file, symbol by symbol.
 * Called mainly by the parser.
 *
 * Bugs:
 * - sloppy code, should really be revised!
 ****/


#include "reader.h"

#include <stdio.h>
#include <sys/stat.h>

#undef __cplusplus
#include <fcntl.h>
#define __cplusplus 1

Reader::Reader( void )
{

   _currline = 1;

   _depth = 0;

   fptr = 0;
   fsize = 0;
}


Reader::~Reader()
{
   if( fptr ) free( fptr );

}


int Reader::LoadFile( char *fname )
{
   struct stat hst;
   int fp;

   if( (fp = open( fname, O_RDONLY, 0 )) != -1 ) {

      if( !fstat( fp, &hst ) ) {

         fsize = (int) hst.st_size;

         if( fptr = (char *) malloc( fsize ) ) {

            read( fp, fptr, fsize );

            _readp = fptr;
            _readmax = fptr+fsize;


         } else
            printf( "Out of memory, size = %d!\n", fsize );

      } else
         printf( "Error getting fstat() on %s!\n", fname );

      close( fp );
   } else
      printf( "Error opening file %s!\n", fname );


   return fptr != 0;
}




int Reader::IsKeyWord( char *word )
{

   if( !(strcmp( word, "PROCEDURE" )) ) return 1;
   if( !(strcmp( word, "BEGIN" )) ) return 1;
   if( !(strcmp( word, "END" )) ) return 1;
   if( !(strcmp( word, "VAR" )) ) return 1;
   if( !(strcmp( word, "IF" )) ) return 1;
   if( !(strcmp( word, "THEN" )) ) return 1;
   if( !(strcmp( word, "ELSE" )) ) return 1;

   return 0;
}

void Reader::ViewErr( char *txt )
{
   printf( "Line %d: %s\n", _currline, txt );
}

void Reader::ViewMsg( char *txt )
{
   for( int i = 0; i < _depth; i++ ) printf( " " );
   puts( txt );
}

void Reader::In( void )
{
   _depth++;
}

void Reader::Out( void )
{
   _depth--;
}


char *Reader::LastSym( void )
{
   return _readlastsym;
}


/***
 * NextSym
 * A symbol is:
 * - something contained in "..."
 * - a keyword (separated by SPACE, TAB, RETURN or ",", converted to uppercase)
 * Comments are skipped (init by %, end by RETURN)
 ***/

int Reader::NextSym( void )
{
   int x;

   _readlastsym[0] = '\0';

   if( _readp >= _readmax ) return 0;

   _readlastsym[0] = *_readp++;
   _readlastsym[1] = '\0';

   // check if this is a special one-char symbol
   switch( _readlastsym[0] ) {

      case ';':
      case '+':
      case '-':
      case '*':
      case '/':
      case '=':
      case '(':
      case ')':
      case '>':
      case ',':
         return 1;
         break;

      default:
         break;

   }

   // Skip spaces/tabs/returns
   while( (_readlastsym[0] == 32 || _readlastsym[0] == 10 || _readlastsym[0] == 9) && _readp < _readmax ) {
      if( _readlastsym[0] == 10 ) _currline++;
      _readlastsym[0] = *_readp++;
   }

   if( _readp >= _readmax ) return 0;


   // Skip blocks of comments
   while( _readlastsym[0] == '%' ) {

      // Skip to end of this comment
      while( (_readlastsym[0] != 10) && (_readp < _readmax) )
         _readlastsym[0] = *_readp++;

      // Skip spaces/tabs/returns
      while( (_readlastsym[0] == 32 || _readlastsym[0] == 10 || _readlastsym[0] == 9) && _readp < _readmax ) {
         if( _readlastsym[0] == 10 ) _currline++;
         _readlastsym[0] = *_readp++;
      }

      if( _readp >= _readmax ) return 0;

   }

   x = 1;

   // return ;
   if( _readlastsym[0] == ';' ) return 1;

   // Deal with "xxx" symbols and normal ones differently

   if( _readlastsym[0] == '"' ) {

      while( (*_readp != '"') && (_readp < _readmax) )
         _readlastsym[x++] = *_readp++;

      _readlastsym[x++] = '"';
      _readp++;

   } else {

      int endit = 0;

      while( !endit ) {

         switch( *_readp ) {

            case ' ':

               endit = 1;
               _readp++;
               break;


            case ',':
            case ';':
            case '+':
            case '-':
            case '*':
            case '/':
            case '=':
            case '(':
            case ')':
            case '>':
            case 10:
            case 9:

               endit = 1;
               break;

            default:
               _readlastsym[x++] = *_readp++;
               break;

         }

      }

   }



   _readlastsym[x] = '\0';

   if( _readp >= _readmax ) return 0;

   for( int i = 0; _readlastsym[i]; i++ )
      _readlastsym[i] = (char) toupper( _readlastsym[i] );

   return x;
}

